import picamera
from time import sleep
import time
import RPi.GPIO as GPIO
import sys
import pygame
import os
import gphoto2 as gp


done = False
exit_button = False
print_button = False
fire_button = False

actual_image = ""

class states(object):
  INIT = 1
  START_PREVIEW = 2
  WAIT_FOR_FIRE = 3
  DISPLAY_IMAGE = 4
  WAIT_FOR_PRINT = 5

state = states.INIT
# WAIT_FOR_FIRE
# WAIT_FOR_PRINT
# PRINT

next_state = state


def take_picture():
   global actual_image
   context = gp.gp_context_new()
   camera = gp.check_result(gp.gp_camera_new())
   gp.check_result(gp.gp_camera_init(camera, context))
   print('Capturing image')
   try:
     file_path = gp.check_result(gp.gp_camera_capture(camera, gp.GP_CAPTURE_IMAGE, context))
     print('Camera file path: {0}/{1}'.format(file_path.folder, file_path.name))
     target = os.path.join('/home/pi/photobox/images/', file_path.name)
     print('Copying image to', target)
     actual_image = target
     camera_file = gp.check_result(gp.gp_camera_file_get(camera, file_path.folder, file_path.name,gp.GP_FILE_TYPE_NORMAL, context))
     gp.check_result(gp.gp_file_save(camera_file, target))
     gp.check_result(gp.gp_camera_exit(camera, context))
     
     print(time.strftime("%Y.%m.%d_%H%M%S"))
     os.system("cp /home/pi/photobox/images/capt0000.jpg /home/pi/photobox/images/KuD_"+ str(time.strftime("%Y.%m.%d_%H%M%S"))+".jpg")
     
   except:
     print "unable to capture"
     actual_image = "/home/pi/photobox/upps.png"
   return 0

bounce_time = 1000
exit_button_pin = 24
fire_pin = 32
print_pin = 26

led_pin_red = 36
led_pin_green = 38
led_pin_white = 40

printed = True

GPIO.setmode(GPIO.BOARD)
GPIO.setup(exit_button_pin, GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup(fire_pin, GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup(print_pin, GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup(led_pin_red, GPIO.OUT)
GPIO.setup(led_pin_green, GPIO.OUT)
GPIO.setup(led_pin_white, GPIO.OUT)


pwm_led_red = GPIO.PWM(led_pin_red,2)
pwm_led_green = GPIO.PWM(led_pin_green,2)
pwm_led_white = GPIO.PWM(led_pin_white,2)


def button_pressed(channel):
  print "button: "
  if channel == exit_button_pin:
     global exit_button
     print "exit_button_pin pressed!"
     exit_button = True
  elif channel == fire_pin:
     global fire_button
     fire_button = True
     print "fire_button_pin pressed!"
  elif channel == print_pin:
     global print_button
     print_button = True
     print "print_button_pin pressed!"



GPIO.add_event_detect(exit_button_pin, GPIO.RISING, callback=button_pressed, bouncetime=bounce_time)
GPIO.add_event_detect(fire_pin, GPIO.FALLING, callback=button_pressed, bouncetime=bounce_time)
GPIO.add_event_detect(print_pin, GPIO.FALLING, callback=button_pressed, bouncetime=bounce_time)


pwm_led_red.start(0)
pwm_led_green.start(0)
pwm_led_white.start(0)

while not done:

 if state == states.INIT:
   print "** INIT **"
   pygame.init()
   pygame.mouse.set_visible(False)
   screen = pygame.display.set_mode((1280, 1024))

   background = pygame.image.load("Fotobox_bg1280x1024.png")

   screen.blit(background, (0,0))
   pygame.display.flip()
   
   next_state = states.START_PREVIEW
   exit_button = False
   print_button = False
   fire_button = False

   camera = picamera.PiCamera()
   camera.resolution = (1181,779)

 if state == states.START_PREVIEW:
   print "** START PREVIEW **"
   next_state = states.WAIT_FOR_FIRE
   camera.start_preview(fullscreen=False, window = (44,64,1181,779))
   camera.vflip = True
   camera.rotation = 270
   #camera.hflip = True
   camera.brightness = 60


 if state == states.WAIT_FOR_FIRE:
   print "** WAIT FOR FIRE **"
   pwm_led_white.start(50)
   if fire_button == True:
     camera.stop_preview()
     image = pygame.image.load("bitte_warten.png")
     screen.blit(image, (0,0))
     pygame.display.flip()
     take_picture()
     next_state = states.DISPLAY_IMAGE
     exit_button = False
     print_button = False
     fire_button = False
     pwm_led_white.start(0)
   if exit_button == True:
     done = True

 if state == states.DISPLAY_IMAGE:
   print "** DISPALY IMAGE **"
   background = pygame.image.load("Fotobox_bg1280x1024.png")
   screen.blit(background, (0,0))
   image = pygame.image.load(actual_image)
   image = pygame.transform.scale(image, (1181, 779))
   screen.blit(image, (44,64))
   pygame.display.flip()
   
   
   if actual_image != "/home/pi/photobox/upps.png":
    pwm_led_red.start(50)
    pwm_led_green.start(50)
   else:
    pwm_led_red.start(50)
   next_state = states.WAIT_FOR_PRINT

 if state == states.WAIT_FOR_PRINT:
   print "** WAIT FOR PRINT **"
   if print_button == True:
      print "print it"
      exit_button = False
      print_button = False
      fire_button = False
      background = pygame.image.load("Fotobox_bg1280x1024.png")
      screen.blit(background, (0,0))
      image = pygame.image.load("verarbeite.png")
      screen.blit(image, (0,0))
      pygame.display.flip()

      pwm_led_red.start(0)
      pwm_led_green.start(0)

      print time.strftime("%Y.%m.%d_%H:%M:%S:") + " start conversion"
      os.system("convert -resize 2071x1400 /home/pi/photobox/images/capt0000.jpg -quality 100 /home/pi/photobox/images/small.jpg")
      os.system("convert -crop 2071x1365 -gravity Center /home/pi/photobox/images/small.jpg /home/pi/photobox/images/crop.jpg")
      os.system("composite -geometry +205+87 /home/pi/photobox/images/crop-0.jpg /home/pi/photobox/images/Fotobox.png /home/pi/photobox/images/output.jpg")
      os.system("composite -geometry +205+1835 /home/pi/photobox/images/small.jpg /home/pi/photobox/images/output.jpg /home/pi/photobox/images/output.jpg")
      print time.strftime("%Y.%m.%d_%H%M%S") + " finished conversion"
      
      background = pygame.image.load("Fotobox_bg1280x1024.png")
      screen.blit(background, (0,0))
      image = pygame.image.load("wird_gedruckt.png")
      screen.blit(image, (0,0))
      pygame.display.flip()
      
      os.system("lp -d Canon_SELPHY_CP1200 /home/pi/photobox/images/output.jpg")
      print time.strftime("%Y.%m.%d_%H%M%S") + " print finished"
      sleep(60)
      background = pygame.image.load("Fotobox_bg1280x1024.png")
      screen.blit(background, (0,0))
      pygame.display.flip()

      
      next_state = states.START_PREVIEW
   if exit_button == True:
      next_state = states.START_PREVIEW
      exit_button = False
      print_button = False
      fire_button = False
      background = pygame.image.load("Fotobox_bg1280x1024.png")
      screen.blit(background, (0,0))
      pygame.display.flip()
      pwm_led_red.start(0)
      pwm_led_green.start(0)
      
 state = next_state
 sleep(0.5)
  
# Clean up on exit
GPIO.cleanup()
sys.exit()
